from wxPython.wx import *
from wxPython.lib.evtmgr import eventManager

ID_CLOSE    = wxNewId()

class PreviewFrame(wxFrame):
	def __init__(self, parent, ID, title, img, pos=wxDefaultPosition,
				 size=wxDefaultSize, style= wxCAPTION| wxSYSTEM_MENU |wxMINIMIZE_BOX):
		wxFrame.__init__(self, parent, ID, title, pos, size, style)
		panel = wxPanel(self, -1)
		
		button = wxButton(self, ID_CLOSE, "Close", size = (80, 30))

		preview = wxStaticBitmap(self, -1,
								 img.ConvertToBitmap(),
								 size = (img.GetWidth(), img.GetHeight()))

		bsizer = wxBoxSizer(wxVERTICAL)
		bsizer.Add(button,)
		bsizer.Add(preview, 1, wxEXPAND)

		eventManager.Register(self.onCloseMe,	  EVT_BUTTON, win=self, id=ID_CLOSE)
		EVT_CLOSE(self, self.onCloseWindow)

		self.SetAutoLayout(1)
		self.SetSizer(bsizer)
		self.Layout()
		
	def __repr__(self):
		return '<%s, address: %s>' % (self.__class__.__name__, id(self))
		
	def onCloseMe(self, event):
		self.Close(1)

	def onCloseWindow(self, event):
		self.Destroy()
