import os, os.path, string, sys, traceback
from wxPython.wx import *
from wxPython.lib.evtmgr import eventManager


class TextOutput(wxTextCtrl):

	def __init__(self, *args, **kwargs):
		apply(wxTextCtrl.__init__,(self,) + args, kwargs)
		self.dirname=''
		self.file=''
		defColour = self.GetDefaultStyle().GetTextColour()
		defFont = self.GetDefaultStyle().GetFont()
		try:
			newFont = wxFont(defFont.GetPointSize(), wxTELETYPE, wxNORMAL, wxNORMAL)
		except:
			print 'No such Font!'
			newFont = defFont
		self.SetDefaultStyle(wxTextAttr(defColour, font = newFont))
		eventManager.Register(self.onRMB, EVT_RIGHT_UP, self) 
		eventManager.Register(self.onRMB, EVT_COMMAND_RIGHT_CLICK, self) 

	def __repr__(self):
		return '<%s, address: %s>' % (self.__class__.__name__, id(self))
		
	def onRMB(self, evt):
		menu = wxMenu()
		ID_CLEARLOG = wxNewId()
		ID_SAVELOG  = wxNewId()
		menu.Append(ID_CLEARLOG, "Clear Log")
		menu.Append(ID_SAVELOG, "Save Log As...")
		eventManager.Register(self.onClear, EVT_MENU, win=self, id=ID_CLEARLOG) 
		eventManager.Register(self.onSaveAs, EVT_MENU, win=self, id=ID_SAVELOG) 
		self.PopupMenu(menu, wxPoint(evt.GetX(), evt.GetY()))
		menu.Destroy()
		evt.Skip()

	def onClear(self, evt):
		self.Clear()

	def onSaveAs(self, evt):
		wildcard = 'Log Files(*.log)|*.log|Text Files(*.txt)|*.txt|All files (*.*)|*.*'
		dlg = wxFileDialog(self, 'Save As...', self.dirname, self.file, wildcard, wxSAVE|wxOVERWRITE_PROMPT)
		if dlg.ShowModal() == wxID_OK:
			self.dirname = os.path.dirname(dlg.GetPath())
			self.file	 = os.path.basename(dlg.GetPath())
			try:
				outfile = open(dlg.GetPath(), 'w')
				outfile.write(self.GetValue())
				outfile.close()
			except:
				type, val, tb = sys.exc_info()
				k = traceback.format_tb(tb, None) + traceback.format_exception_only(type, val)
				traceo = string.join([string.lstrip(l) for l in k])
				dlg = wxMessageDialog(self,
									  'An error occured writing the renderlog!\n'+traceo,
									  'ERROR!',
									  wxOK | wxICON_ERROR)
				ok = dlg.ShowModal()

